using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Identity;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System.Security.Claims;

namespace TestIdentityServer
{
    /// <summary>
    /// α׷
    /// </summary>
    public class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region α׷ ϱ - Main(argumentArray)

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        /// <param name="argumentArray"> 迭</param>
        public static void Main(string[] argumentArray)
        {
            IHost host = CreateHostBuilder(argumentArray).Build();

            using(IServiceScope scope = host.Services.CreateScope())
            {
                UserManager<IdentityUser> userManager = scope.ServiceProvider.GetRequiredService<UserManager<IdentityUser>>();

                IdentityUser user = new IdentityUser("alice");

                userManager.CreateAsync(user, "alice").GetAwaiter();

                userManager.AddClaimAsync(user, new Claim("user.claim", "VALUE0001")).GetAwaiter();
            }
            
            host.Run();
        }

        #endregion
        #region ȣƮ  ϱ - CreateHostBuilder(argumentArray)

        /// <summary>
        /// ȣƮ  ϱ
        /// </summary>
        /// <param name="argumentArray"> 迭</param>
        /// <returns>ȣƮ </returns>
        public static IHostBuilder CreateHostBuilder(string[] argumentArray) =>
            Host.CreateDefaultBuilder(argumentArray)
                .ConfigureWebHostDefaults
                (
                    builder =>
                    {
                        builder.UseStartup<Startup>();
                    }
                );

        #endregion
    }
}